#ifndef __TM1628_H
#define __TM1628_H

//----------------------------------------------------------//
//      TM1628                 //
//----------------------------------------------------------//

//----------------------------------------------------------//
//                            //
//----------------------------------------------------------//

#define ADDR_AUTO              0x40                         //   
#define ADDR_FIXED             0x44                         //  
#define READ_KEY               0X42                         //  

#define DISPLAY_OFF            0X80                         //  LED 
#define DISPLAY_ON             0X88                         //  LED 

#define DIG1                   0XC0                         //  1
#define DIG2                   0XC2                         //  2
#define DIG3                   0XC4                         //  3
#define DIG4                   0XC6                         //  4
#define DIG5                   0XC8                         //  5
#define DIG6                   0XCA                         //  6
#define DIG7                   0XCC                         //  7

#define INTENSITY_1            0X00                         //   1 1/16
#define INTENSITY_2            0X01                         //   2 2/16
#define INTENSITY_3            0X02                         //   3 4/16
#define INTENSITY_4            0X03                         //   4 10/16
#define INTENSITY_5            0X04                         //   5 11/16
#define INTENSITY_6            0X05                         //   6 12/16
#define INTENSITY_7            0X06                         //   7 13/16
#define INTENSITY_8            0X07                         //   8 14/16
#define INTENSITY_MIN          0x00                         //   
#define INTENSITY_MAX          0x07                         //   

#define SEG_A                  0x01                         //  
#define SEG_B                  0x02                         //  B
#define SEG_C                  0x04                         //  C
#define SEG_D                  0x08                         //  D
#define SEG_E                  0x10                         //  E
#define SEG_F                  0x20                         //  F
#define SEG_G                  0x40                         //  G
#define SEG_DP                 0x80                         //  DP

#define SYM_GRADUS             0x63                         //   
#define SYM_DP                 0x80                         // /
#define SYM_2VLINE             0x22                         // 2  
#define SYM_2HLINE_V1          0x08                         // 2    1
#define SYM_2HLINE_V2          0x48                         // 2    2
#define SYM_3HLINE             0x49                         // 3  

#define _A                     0x77
#define _B                     0x7f
#define _C                     0x39
#define _D                     0x3f
#define _E                     0x79
#define _F                     0x71
#define _G                     0x3d
#define _H                     0x76
#define _I                     0x30
#define _J                     0x1e
#define _L                     0x38
#define _ML                    0x33
#define _MR                    0x27
#define _N                     0x37
#define _O                     0x3f
#define _P                     0x73
#define _S                     0x6d
#define _U                     0x3e
#define _Y                     0x6e
#define _a                     0x5f
#define _b                     0x7c
#define _c                     0x58
#define _d                     0x5e
#define _e                     0x7b
#define _f                     0x71
#define _h                     0x74
#define _i                     0x10
#define _j                     0x0e
#define _l                     0x06
#define _n                     0x54
#define _o                     0x5c
#define _q                     0x67
#define _r                     0x50
#define _t                     0x78
#define _u                     0x1c
#define _y                     0x6e
#define _dash                  0x40
#define _minus                 0x40
#define _under                 0x08
#define _equal                 0x48
#define _empty                 0x00
#define _degree                0x63
#define _dp                    0x80

#define _0                     0x3f
#define _1                     0x06
#define _2                     0x5b
#define _3                     0x4f
#define _4                     0x66
#define _5                     0x6d
#define _6                     0x7d
#define _7                     0x07
#define _8                     0x7f
#define _9                     0x6f

//----------------------------------------------------------//
//                                         //
//----------------------------------------------------------//

void TM1628_Init(void);                                     //  
void TM1628_DisplayClear(void);                             //   
void TM1628_DisplaySetIntensity(uint8_t PWM);               //    
void TM1628_DisplayOff(void);                               //   
void TM1628_DisplayOn(void);                                //   
void TM1628_WriteData(uint8_t Dig, uint8_t Data);           //       TM1628
void TM1628_DisplayArray(uint8_t SendData[]);               //   
void TM1628_DisplayShowTime(uint8_t Hour, uint8_t Min);     //     RTC DS3231
void TM1628_DisplayShowTemp(short Temp);                    //     DS18B20
void TM1628_RunningString(uint8_t DispData[], uint8_t Amount, uint16_t DelayMs); //   

#endif
