//----------------------------------------------------------//
//     SPI                          //
//----------------------------------------------------------//

//----------------------------------------------------------//
//                     //
//----------------------------------------------------------//

#include "STM8S103.h"
#include "stm8s_spi.h"
#include "main.h"

//----------------------------------------------------------//
//   SPI                                //
//----------------------------------------------------------//

void SPI_Init(void)
{
  SPI_CR1 = 0x83; // SPI_FIRSTBIT_LSB, SPI_BAUDRATEPRESCALER_2, SPI_CLOCKPOLARITY_HIGH, SPI_CLOCKPHASE_2EDGE
  SPI_CR2 = 0xc2;                                           // SPI_DATADIRECTION_1LINE_TX, SPI_NSS_SOFT
  SPI_CR2 |= 0x01;                                          // Software NSS enabled
  SPI_CR1 |= 0x04;                                          // Master mode configuration
  SPI_CRCPR = 0x07;                                         // CRC configuration
  SPI_CR1 |= 0x40;                                          // Enable the SPI peripheral
}

//----------------------------------------------------------//
//     SPI                            //
//----------------------------------------------------------//

void SPI_SendData(uint8_t Data)
{
  SPI_DR = Data;
  while(!(SPI_SR & 0x02)) {}
  delay_mks(1);
}
