#ifndef __MAIN_H
#define __MAIN_H

//----------------------------------------------------------//
//                     //
//----------------------------------------------------------//

#include "STM8S103.h"

//----------------------------------------------------------//
//                                    //
//----------------------------------------------------------//

#define DAY                       0
#define NIGHT                     1
#define ENABLE                    1
#define DISABLE                   0
#define ON                        1
#define OFF                       0
#define LEFT                      0
#define RIGHT                     1

// 
#define KEY_MENU                  GPIO_PIN_5                // PD5
#define KEY_OK                    GPIO_PIN_6                // PD6
#define KEY_PLUS                  GPIO_PIN_1                // PA1
#define KEY_MINUS                 GPIO_PIN_2                // PA2
#define KEY_PORT1                 PD_IDR
#define KEY_PORT2                 PA_IDR

// TLI -     PC3.  SQW 1  RTC
#define TLI_PORT                  GPIOC
#define TLI_PIN                   GPIO_PIN_3

//        
#define PWM_PIN                   GPIO_PIN_3                // PA3 -   TIM2 CH3

// EEPROM -   
#define EE_ADDR_CHECK_SETUPS        0x004000
#define EE_ADDR_HOUR_NIGHT_ON       0x004001
#define EE_ADDR_HOUR_NIGHT_OFF      0x004002
#define EE_ADDR_NIGHT_MODE          0x004003
#define EE_ADDR_TIME_SHOW_CLOCK     0x004004
#define EE_ADDR_TIME_SHOW_TEMP      0x004005
#define EE_ADDR_BRIGHTNESS          0x004006
#define EE_ADDR_HEART_EFF           0x004007
#define EE_ADDR_HEART_EFF_SEC       0x004008
#define EE_ADDR_HEART_EFF_SEC_PER   0x004009
#define EE_ADDR_HEART_BRIGH_D_PNT   0x00400A

//----------------------------------------------------------//
//                                         //
//----------------------------------------------------------//

void delay_mks(uint16_t mks);                               //    
void delay_ms(uint16_t ms);                                 //    

#endif
