//----------------------------------------------------------//
//                                           //
//----------------------------------------------------------//

//----------------------------------------------------------//
//                     //
//----------------------------------------------------------//

#include "STM8S103.h"
#include "main.h"
#include "menu.h"
#include "SN74HC595.h"
#include "TM1628.h"
#include "DS3231.h"

//----------------------------------------------------------//
//                            //
//----------------------------------------------------------//

//----------------------------------------------------------//
//                   //
//----------------------------------------------------------//

// 
const uint8_t SetupTxt[4] = { _S,_E,_t,_empty };

// 
const uint8_t SaveTxt[4] = { _S,_A,_U,_E };

//   
const uint8_t MenuItemTxt[3][4] = {
  { _C,_L,_O,_C },
  { _d,_I,_S,_P },
  { _L,_O,_U,_E }
};

//   
const uint8_t SubMenuItemTxt[3][4][4] = {
  //     
  {
    { _t,_I,_ML,_MR },
    { _N,_I,_G,_H },
    { _N,_t,_Y,_P }
  },
  //   , , 
  {
    { _t,_I,_ML,_MR },
    { _t,_ML,_MR,_P },
    { _b,_r,_i,_G }
  },
  //  
  {
    { _L,_d,_A,_Y },
    { _E,_F,_F,_1 },
    { _E,_F,_F,_2 },
    { _P,_E,_r,_i }
  }
};

//  TM1628
extern const uint8_t TM1628_Font[];
extern struct DS3231_DateTime DS3231_ReadDate;              //     
extern uint8_t IdxEsEff;                                    //     . 
extern uint8_t KeyProcessing;                               //  . 1 - , 0 - 
extern uint8_t HourNightOn;                                 //    
extern uint8_t HourNightOff;                                //    
extern uint8_t NightMode;                                   //  . 0 -  , 1 - 2 
extern uint8_t TimeShowClock;                               //   
extern uint8_t TimeShowTemp;                                //   
extern uint8_t Brightness;                                  //   
extern uint8_t HeartEff;                                    //   . . 1 - 3 .
extern uint8_t HeartEffSec;                                 // .  . 0 - , 1 - 9 
extern uint8_t HeartEffSecPer;                              //  .  . 0 - , 1 - 60.
extern uint8_t HeartBrightDayPer;                           //     %. 0 - 

uint8_t Menu = 0;                                           // 1 -  , 0 - 
uint8_t MenuSel = 0;                                        //    
uint8_t SubMenuSel = 0;                                     //   
uint8_t SubMenuPos = 0;                                     //     
uint8_t MenuLevel = 0;                                      //   
uint8_t ShowMenuItem = 0;                                   //      
uint8_t ShowSubMenuItem = 0;                                //     
uint8_t DispData[4] = {0};                                  //    

//----------------------------------------------------------//
//                                         //
//----------------------------------------------------------//

static void Menu_ItemProcessing(void);                      //    
static void Menu_DisplayBuff(uint8_t R1, uint8_t R2, uint8_t R3, uint8_t R4); //      
extern void Heart_SetBrightness(uint8_t Value);             //      
extern void EE_SavingConfig(void);                          //     EEPROM
extern void GoToReboot(void);                               //  

//----------------------------------------------------------//
//                                      //
//----------------------------------------------------------//

void Menu_Processing(void)
{
  uint8_t dlyCnt = 0;

  TM1628_DisplayArray(&SetupTxt[0]);
  Menu = 1;
  MenuSel = 0;
  MenuLevel = 0;
  ShowMenuItem = 1;
  KeyProcessing = 1;
  delay_ms(2000);
  while (1) {
    if (KeyProcessing == 1) {
      if (!(MenuSel == 0 && MenuLevel == 2 && SubMenuSel < 2)) {
        Menu_ItemProcessing();
      }
      dlyCnt = 0;
      KeyProcessing = 0;
      while ( ((KEY_PORT1 & KEY_MENU) == 0) ||
        ((KEY_PORT1 & KEY_OK) == 0) ||
        ((KEY_PORT2 & KEY_PLUS) == 0) ||
        ((KEY_PORT2 & KEY_MINUS) == 0) ) { } //   ,   
        delay_ms(100);
    }
    if (MenuSel == 0 && MenuLevel == 2 && SubMenuSel < 2) {
      if (dlyCnt == 0) Menu_ItemProcessing();
      if (++dlyCnt == 4) dlyCnt = 0;
    }

    // MENU******************************
    if ((KEY_PORT1 & KEY_MENU) == 0) {
      switch (MenuLevel) {
        case 0:
          TM1628_DisplayArray(&SaveTxt[0]);
          EE_SavingConfig();
          delay_ms(1000);
          GoToReboot();
          break;
        case 1:
          MenuLevel--;
          ShowMenuItem = 1;
          KeyProcessing = 1;
          break;
        case 2:
          if (MenuSel == 0 && SubMenuSel < 2) {
            DS3231_ReadDate.Seconds = 0;
            DS3231_SetDateTime(&DS3231_ReadDate); //    
          }
          MenuLevel--;
          SubMenuPos = 0;
          ShowSubMenuItem = 1;
          KeyProcessing = 1;
          break;
      }
    }

    // PLUS******************************
    if ((KEY_PORT2 & KEY_PLUS) == 0) {
      switch (MenuLevel) {
        case 0:
          if (MenuSel != 0) {
            MenuSel--;
            ShowMenuItem = 1;
            KeyProcessing = 1;
          }
          break;
        case 1:
          if (SubMenuSel != 0) {
            SubMenuSel--;
            ShowSubMenuItem = 1;
            KeyProcessing = 1;
          }
          break;
        case 2:
          switch (MenuSel) {
            case 0:
              if (SubMenuSel == 0) {
                if (SubMenuPos == 0) {
                  if (DS3231_ReadDate.Hour == 23) {
                    DS3231_ReadDate.Hour = 0;
                  } else {
                    DS3231_ReadDate.Hour++;
                  }
                } else if (SubMenuPos == 1) {
                  if (DS3231_ReadDate.Minutes == 59) {
                    DS3231_ReadDate.Minutes = 0;
                  } else {
                    DS3231_ReadDate.Minutes++;
                  }
                }
              } else if (SubMenuSel == 1) {
                if (SubMenuPos == 0) {
                  if (HourNightOn == 23) {
                    HourNightOn = 0;
                  } else {
                    HourNightOn++;
                  }
                } else if (SubMenuPos == 1) {
                  if (HourNightOff == 23) {
                    HourNightOff = 0;
                  } else {
                    HourNightOff++;
                  }
                }
              } else if (SubMenuSel == 2) {
                if (NightMode == 2) {
                  NightMode = 0;
                } else {
                  NightMode++;
                }
              }
              break;
            case 1:
              switch (SubMenuSel) {
                case 0:
                  if (TimeShowClock == 60) {
                    TimeShowClock = 3;
                  } else {
                    TimeShowClock++;
                  }
                  break;
                case 1:
                  if (TimeShowTemp == 8) {
                    TimeShowTemp = 1;
                  } else {
                    TimeShowTemp++;
                  }
                  break;
                case 2:
                  if (Brightness == 7) {
                    Brightness = 1;
                  } else {
                    Brightness++;
                  }
                  break;
              }
              break;
            case 2:
              switch (SubMenuSel) {
                case 0:
                  if (HeartBrightDayPer == 100) {
                    HeartBrightDayPer = 0;
                  } else {
                    HeartBrightDayPer++;
                  }
                  break;
                case 1:
                  if (HeartEff == 4) {
                    HeartEff = 0;
                  } else {
                    HeartEff++;
                  }
                  break;
                case 2:
                  if (HeartEffSec == 9) {
                    HeartEffSec = 0;
                  } else {
                    HeartEffSec++;
                  }
                  break;
                case 3:
                  if (HeartEffSecPer == 60) {
                    HeartEffSecPer = 0;
                  } else {
                    HeartEffSecPer++;
                  }
              }
              break;
          }
          KeyProcessing = 1;
          break;
      }
    }

    // MINUS******************************
    if ((KEY_PORT2 & KEY_MINUS) == 0) {
      switch (MenuLevel) {
        case 0:
          if (MenuSel < 2) {
            MenuSel++;
            ShowMenuItem = 1;
            KeyProcessing = 1;
          }
          break;
        case 1:
          if (!(MenuSel < 2 && SubMenuSel == 2) && SubMenuSel < 3) {
            SubMenuSel++;
            ShowSubMenuItem = 1;
            KeyProcessing = 1;
          }
          break;
        case 2:
          switch (MenuSel) {
            case 0:
              if (SubMenuSel == 0) {
                if (SubMenuPos == 0) {
                  if (DS3231_ReadDate.Hour == 0) {
                    DS3231_ReadDate.Hour = 23;
                  } else {
                    DS3231_ReadDate.Hour--;
                  }
                } else if (SubMenuPos == 1) {
                  if (DS3231_ReadDate.Minutes == 0) {
                    DS3231_ReadDate.Minutes = 59;
                  } else {
                    DS3231_ReadDate.Minutes--;
                  }
                }
              } else if (SubMenuSel == 1) {
                if (SubMenuPos == 0) {
                  if (HourNightOn == 0) {
                    HourNightOn = 23;
                  } else {
                    HourNightOn--;
                  }
                } else if (SubMenuPos == 1) {
                  if (HourNightOff == 0) {
                    HourNightOff = 23;
                  } else {
                    HourNightOff--;
                  }
                }
              } else if (SubMenuSel == 2) {
                if (NightMode == 0) {
                  NightMode = 2;
                } else {
                  NightMode--;
                }
              }
              break;
            case 1:
              switch (SubMenuSel) {
                case 0:
                  if (TimeShowClock == 3) {
                    TimeShowClock = 60;
                  } else {
                    TimeShowClock--;
                  }
                  break;
                case 1:
                  if (TimeShowTemp == 1) {
                    TimeShowTemp = 8;
                  } else {
                    TimeShowTemp--;
                  }
                  break;
                case 2:
                  if (Brightness == 1) {
                    Brightness = 7;
                  } else {
                    Brightness--;
                  }
                  break;
              }
              break;
            case 2:
              switch (SubMenuSel) {
                case 0:
                  if (HeartBrightDayPer == 0) {
                    HeartBrightDayPer = 100;
                  } else {
                    HeartBrightDayPer--;
                  }
                  break;
                case 1:
                  if (HeartEff == 0) {
                    HeartEff = 4;
                  } else {
                    HeartEff--;
                  }
                  break;
                case 2:
                  if (HeartEffSec == 0) {
                    HeartEffSec = 9;
                  } else {
                    HeartEffSec--;
                  }
                  break;
                case 3:
                  if (HeartEffSecPer == 0) {
                    HeartEffSecPer = 60;
                  } else {
                    HeartEffSecPer--;
                  }
              }
              break;
          }
          KeyProcessing = 1;
          break;
      }
    }

    // OK / ENTER**********************
    if ((KEY_PORT1 & KEY_OK) == 0) {
      if (MenuLevel < 2) {
        MenuLevel++;
        if (MenuLevel == 1 && MenuSel < 3) {
          if (MenuSel == 2) Heart_State(ON);
          SubMenuSel = 0;
          SubMenuPos = 0;
          ShowSubMenuItem = 1;
        }
        if (MenuSel == 0 && MenuLevel == 2 && SubMenuSel < 2) {
          DS3231_GetDateTime(&DS3231_ReadDate);
        }
        KeyProcessing = 1;
      } else {
        if (MenuSel == 0 && SubMenuSel < 2 && SubMenuPos < 2) {
          SubMenuPos++;
          KeyProcessing = 1;
        }
      }
    }
    delay_ms(50);
  }
}

//----------------------------------------------------------//
//                               //
//----------------------------------------------------------//

static void Menu_ItemProcessing(void)
{
  uint8_t i;
  static uint8_t blink = 1;

  if (ShowMenuItem) {
    TM1628_DisplayArray(&MenuItemTxt[MenuSel][0]);
    ShowMenuItem = 0;
  } else {
    if (ShowSubMenuItem) {
      TM1628_DisplayArray(&SubMenuItemTxt[MenuSel][SubMenuSel][0]);
      ShowSubMenuItem = 0;
    }
  }
  if (MenuLevel == 2) {
    switch (MenuSel) {
      case 0:
        if (SubMenuSel == 0) {
          Menu_DisplayBuff(TM1628_Font[((DS3231_ReadDate.Hour%100)/10)],
            TM1628_Font[(DS3231_ReadDate.Hour%100)%10],
            TM1628_Font[(DS3231_ReadDate.Minutes/10)],
            TM1628_Font[(DS3231_ReadDate.Minutes%10)]);
        } else if (SubMenuSel == 1) {
          if (HourNightOn != HourNightOff) {
            Menu_DisplayBuff(TM1628_Font[(HourNightOn/10)],
              TM1628_Font[(HourNightOn%10)],
              TM1628_Font[(HourNightOff/10)],
              TM1628_Font[(HourNightOff%10)]);
          } else {
            Menu_DisplayBuff(_empty,_O,_F,_F);
            break;
          }
        } else if (SubMenuSel == 2) {
          Menu_DisplayBuff(_empty,_empty,TM1628_Font[NightMode],_empty);
          break;
        }
        blink =! blink;
        if (blink) {
          if (SubMenuPos == 0) {
            DispData[0] = _empty;
            DispData[1] = _empty;
          } else {
            DispData[2] = _empty;
            DispData[3] = _empty;
          }
        }
        break;
      case 1:
        switch (SubMenuSel) {
          case 0:
            if (TimeShowClock >= 10) {
              Menu_DisplayBuff(_empty,TM1628_Font[TimeShowClock/10],
                TM1628_Font[TimeShowClock%10],_c);
            } else {
              Menu_DisplayBuff(_empty,_empty,TM1628_Font[TimeShowClock],_c);
            }
            break;
          case 1:
            Menu_DisplayBuff(_empty,_empty,TM1628_Font[TimeShowTemp],_c);
            break;
          case 2:
            Menu_DisplayBuff(_L,_empty,TM1628_Font[Brightness],_empty);
            TM1628_DisplaySetIntensity(Brightness);
            break;
        }
        break;
      case 2:
        switch (SubMenuSel) {
          case 0:
            if (HeartBrightDayPer) {
              if (HeartBrightDayPer == 100) {
                Menu_DisplayBuff(_empty,TM1628_Font[HeartBrightDayPer/100],
                  TM1628_Font[((HeartBrightDayPer%100)/10)],TM1628_Font[(HeartBrightDayPer%100)%10]);
              } else if (HeartBrightDayPer >= 10) {
                Menu_DisplayBuff(_empty,TM1628_Font[HeartBrightDayPer/10],TM1628_Font[HeartBrightDayPer%10],_empty);
              } else {
                Menu_DisplayBuff(_empty,_empty,TM1628_Font[HeartBrightDayPer],_empty);
              }
            } else {
              Menu_DisplayBuff(_empty,_O,_F,_F);
            }
            Heart_SetBrightness(HeartBrightDayPer);
            break;
          case 1:
            if (HeartEff) {
              Menu_DisplayBuff(_empty,_empty,TM1628_Font[HeartEff],_empty);
              TM1628_DisplayArray(&DispData[0]);
              IdxEsEff = 0;
              switch (HeartEff) {
                case 1:
                  Heart_State(ON);
                  break;
                case 2:
                  for (i = 0; i < 3; i++)
                  {
                    Heart_Eff1EverySecShow(); //  #1  / ( )
                  }
                  break;
                case 3:
                  for (i = 0; i < 14; i++)
                  {
                    Heart_Eff2EverySecShow(); //  #2   
                    delay_ms(150);
                  }
                  break;
                case 4:
                  for (i = 0; i < 8; i++)
                  {
                    Heart_Eff3EverySecShow(); //  #3     2- 
                    delay_ms(150);
                  }
                  break;
                default:
                  break;
              }
              Heart_SetBrightness(HeartBrightDayPer);
            } else {
              Menu_DisplayBuff(_empty,_O,_F,_F);
              Heart_State(OFF);
            }
            break;
          case 2:
            if (HeartEffSec) {
              if (HeartEffSec >= 10) {
                Menu_DisplayBuff(_empty,TM1628_Font[HeartEffSec/10],
                  TM1628_Font[HeartEffSec%10],_empty);
              } else {
                Menu_DisplayBuff(_empty,_empty,TM1628_Font[HeartEffSec],_empty);
              }
              TM1628_DisplayArray(&DispData[0]);
              switch (HeartEffSec) {
                case 1:
                  Heart_Eff1Show();      //  #1   2-  c 
                  break;
                case 2:
                  Heart_Eff2Show();      //  #2      
                  break;
                case 3:
                  Heart_Eff3Show();      //  #3       
                  break;
                case 4:
                  Heart_Eff4Show();      //  #4    
                  break;
                case 5:
                  Heart_Eff5Show();      //  #5   (4  )
                  break;
                case 6:
                  Heart_Eff6Show(RIGHT); //  #6    
                  break;
                case 7:
                  Heart_Eff6Show(LEFT);  //  #6    
                  break;
                case 8:
                  Heart_Eff7Show();      //  #7  .   
                  break;
                case 9:
                  Heart_Eff8Show();      //  #8  .     
                  break;
                default:
                  break;
              }
            } else {
              Menu_DisplayBuff(_A,_U,_t,_O);
            }
            Heart_State(ON);
            break;
          case 3:
            if (HeartEffSecPer) {
              if (HeartEffSecPer >= 10) {
                Menu_DisplayBuff(TM1628_Font[HeartEffSecPer/10],
                  TM1628_Font[HeartEffSecPer%10],_ML,_MR);
              } else {
                Menu_DisplayBuff(_empty,TM1628_Font[HeartEffSecPer],_ML,_MR);
              }
            } else {
              Menu_DisplayBuff(_empty,_O,_F,_F);
            }
            break;
        }
        break;
    }
    TM1628_DisplayArray(&DispData[0]);
  }
}

static void Menu_DisplayBuff(uint8_t R1, uint8_t R2, uint8_t R3, uint8_t R4)
{
  DispData[0] = R1;
  DispData[1] = R2;
  DispData[2] = R3;
  DispData[3] = R4;
}
